* See [CONTRIBUTING.md](CONTRIBUTING.md) for general contribution guidelines.
* See [GOVERNANCE.md](GOVERNANCE.md) for governance guidelines and maintainer responsibilities.

This page lists all active maintainers and their areas of expertise. This can be used for
routing PRs, questions, etc. to the right place.

# Senior maintainers

* Matt Klein ([mattklein123](https://github.com/mattklein123)) (mklein@lyft.com)
  * Catch-all, "all the things", and generally trying to make himself obsolete as fast as
    possible.
* Harvey Tuch ([htuch](https://github.com/htuch)) (htuch@google.com)
  * APIs, xDS, gRPC, configuration, Bazel/build, base server (startup, etc.), Python, and Bash.
* Alyssa Wilk ([alyssawilk](https://github.com/alyssawilk)) (alyssar@google.com)
  * HTTP, flow control, cluster manager, load balancing, and core networking (listeners,
    connections, etc.).
* Stephan Zuercher ([zuercher](https://github.com/zuercher)) (stephan@turbinelabs.io)
  * Load balancing, upstream clusters and cluster manager, logging, complex HTTP routing
    (metadata, etc.), and OSX build.
* Greg Greenway ([ggreenway](https://github.com/ggreenway)) (ggreenway@apple.com)
  * TCP proxy, TLS, logging, and core networking (listeners, connections, etc.).

# Maintainers

* Constance Caramanolis ([ccaraman](https://github.com/ccaraman)) (ccaramanolis@lyft.com)
  * Rate limiting, IP tagging, HTTP routing, configuration/operational questions.
* Jose Nino ([junr03](https://github.com/junr03)) (jnino@lyft.com)
  * Outlier detection, HTTP routing, xDS, configuration/operational questions.
* Dan Noé ([dnoe](https://github.com/dnoe)) (dpn@google.com)
  * Base server (watchdog, workers, startup, stack trace handling, etc.).
* Daniel Hochman ([danielhochman](https://github.com/danielhochman)) (dhochman@lyft.com)
  * Redis, Python, configuration/operational questions.
* Lizan Zhou ([lizan](https://github.com/lizan)) (lizan@tetrate.io)
  * gRPC, gRPC/JSON transcoding, and core networking (transport socket abstractions).
* Dhi Aurrahman ([dio](https://github.com/dio)) (dio@tetrate.io)
  * Lua, access logging, and general miscellany.

# Emeritus maintainers

* Roman Dzhabarov ([RomanDzhabarov](https://github.com/RomanDzhabarov)) (rdzhabarov@lyft.com)
* Bill Gallagher ([wgallagher](https://github.com/wgallagher)) (bgallagher@lyft.com)

# Friends of Envoy

This section lists a few people that are not maintainers but typically help out with subject
matter expert reviews. Feel free to loop them in as needed.

* Piotr Sikora ([PiotrSikora](https://github.com/PiotrSikora)) (piotrsikora@google.com)
  * TLS, BoringSSL, and core networking (listeners, connections, etc.).
* Shriram Rajagopalan ([rshriram](https://github.com/rshriram)) (shriram@us.ibm.com)
  * Istio, APIs, HTTP routing, and WebSocket.
* John Millikin ([jmillikin-stripe](https://github.com/jmillikin-stripe)) (jmillikin@stripe.com)
  * Bazel/build.
* Joshua Marantz ([jmarantz](https://github.com/jmarantz)) (jmarantz@google.com)
  * abseil and performance work.
